//var VERSION_CODE = "1.4(2)";
var VERSION_CODE = "1.4.2(3)";

var Main = function () {
    var _self = this;
    var requesterAjax = null;
    var _isIOS = false;
    var _isAndroid = false;
    var map;
    var watchID = null;
    var initialPointMap = { x: -15.79580, y: -47.89372 };//monumenta
    var geoPositionAccuracy = 200;
    var DefaultMapZoom = 18;
    var infowindow;
    _self.paginationTutorial = 0;
    var firstViewSelecione = true;//ajuda a determinar quando a tela de selcione está sendo vista pela primeira vez, para que o usuário possa buscar uma transação pendente
    var clicked_SERVICE_OS = false;
    var androidBugado = false;

    var countClick = 0;
    var controlClick;

    var tiposSolicitacao = Array();
    tiposSolicitacao[1] = "Indicação de cliente";
    tiposSolicitacao[2] = "Solicitação de serviço";
    tiposSolicitacao[3] = "Credenciamento";
    tiposSolicitacao[4] = "Máquina adicional";
    tiposSolicitacao[5] = "Fidelizaçao";
    tiposSolicitacao[6] = "Problemas com a máquina";
    tiposSolicitacao[7] = "Bobina";
    tiposSolicitacao[8] = "Sinalização";

    var places = [];

    var userToken = ""; //fake token	
    var username = "";
    var password = "";
    var regulamentoAceito = false;

    //homologação
    //var BASE_URL = "http://redeconectaserviceshomolog.azurewebsites.net/";
	
    //URL do ambiente de Produção (V1) (Foi criada outra URL para manter compatibiliade com os Apps que estão na versão inicial)
    var BASE_URL = "http://redeconectaservices-v1.azurewebsites.net/";


    var SERVICE_RECOVERY = { type: "SERVICE_RECOVERY", url: "api/Seguranca/RecuperarSenha" };
    var SERVICE_LOGIN = { type: "SERVICE_LOGIN", url: "api/Seguranca/Autenticar" };
    var SERVICE_REGULATION = { type: "SERVICE_REGULATION", url: "api/Seguranca/AceitarRegulamento" };
    var SERVICE_OS = { type: "SERVICE_OS", url: "api/Solicitacao/Incluir" };
    var SERVICE_FOUR_SQUARE = { type: "SERVICE_FOUR_SQUARE", url: "api/Integracao/BuscarFoursquare" };
    var SERVICE_REGISTER = { type: "SERVICE_REGISTER", url: "api/Seguranca/CadastrarUsuario" };

    var transaction = null;
    var TRANSACTION_INDIQUE = 1;
    var TRANSACTION_SOLICITE = 2;

    var USER_FAKE = "1234";
    var PASSWORD_FAKE = "12312312312";

    var NAVIGATION_NEXT = null; //identifica a proxima página a navegar
    var NAVIGATION_PREV = null; //identifica a anterior página a navegar
    var fnValidNavigation = null; //função que será chamada para validar a navegação

    var ctrlAutoHideMessage = null;	//controlador de tempo de exibição do alerta

    /*=====================  função inicial do app.*/
    _self.init = function () {
        //navigator.splashscreen.show();	
        $.mobile.activeBtnClass = 'unused';

        layoutAdapter();//prepara o layout conforme o OS
        layoutHeightPercent(); //heigth adaptação por percentual
        checkUserLogged();
        setEvents();//starta os eventos
        if (androidBugado) {
            setTimeout(function () {
                alert("Para o correto funcionamento deste e de outros aplicativos, recomendamos que você atualize sua versão do Android. A versão que você está utilizando é muito antiga é apresenta algumas incompatibilidades com este aplicativo.");
            }, 4000);
        }

    }
    /**================== eventos ===================================================*/
    var checkUserLogged = function () {
        try {
            if (window.localStorage.getItem("username")) {
                prepareLogin();

                userToken = window.localStorage.getItem("token");
                username = window.localStorage.getItem("username");
                password = window.localStorage.getItem("password");

                $("#tfSenha").attr("disabled", true);
                $("#tfLogin").attr("disabled", true);
                $("#btLogin").attr("disabled", true);
                $("#placeLogin").hide();

                $("#loginMessage").text("Aguarde autenticando...");
                showMessageAutoHide("Aguarde autenticando...", 1);
                getJson({}, SERVICE_LOGIN);

            } else {
                //navigator.splashscreen.hide();
                prepareLogin();
            }
        } catch (err) {
            prepareLogin();
        }
    }
    var prepareNavigation = function () //eventos das setas de navegação
    {
        $("#prevButton, #btSairCadastro").unbind("tap");
        $("#prevButton, #btSairCadastro").bind("tap", prevPageNavigation);

        $("#nextButton").unbind("tap");
        $("#nextButton").bind("tap", function () {

            if (NAVIGATION_NEXT && (fnValidNavigation == null || fnValidNavigation())) {
                $("#nextButton").unbind("tap");
                $.mobile.changePage(NAVIGATION_NEXT, { transition: "slide" });
                clearNavigationControls();
            }

        });
    }
    var prevPageNavigation = function ()/// navegação para o back, serve tanto para as setas quanto para o botão de back do android
    {
        abortConnection();
        if ($.mobile.activePage.attr("id") == "cadastro") {
            $("#prevButton, #btSairCadastro").unbind("tap");
            $.mobile.changePage("index.html", { transition: "slide", reverse: true });

        } else {
            if (NAVIGATION_PREV) {
                $("#prevButton, #btSairCadastro").unbind("tap");
                $.mobile.changePage(NAVIGATION_PREV, { transition: "slide", reverse: true });
                clearNavigationControls();
            }
        }
    }
    var clearNavigationControls = function () //função para limpesa dos controles
    {
        NAVIGATION_NEXT = null;
        NAVIGATION_PREV = null;
        fnValidNavigation = null;
    }
    var onChangePageHandler = function ()//função que verifica a pagina que entrou e chama a configuração da pagina
    {
        setTimeout(function () {
            auxOnChangePageHandler()
        }, 100);
    }
    var abortConnection = function () {
        try {
            navigator.geolocation.clearWatch(watchID);
        } catch (err) {
            console.log("Não foi possivel finalizar o gps!")
        }
        if (requesterAjax != null) {
            try {
                requesterAjax.abort();
            } catch (err) {
                console.log("Não foi possivel finalizar o request do JSON!")
            }
        }
    }
    var auxOnChangePageHandler = function ()//função que verifica a pagina que entrou e chama a configuração da pagina
    {
        abortConnection();
        switch ($.mobile.activePage.attr("id")) {
            case "home":
                prepareRegulamento();
                break;
            case "seleciona":
                prepareSelecione();
                break;
            case "localidade":
                if (transaction.tipoSolicitacao == TRANSACTION_INDIQUE) {
                    NAVIGATION_PREV = "#servico_indica";
                } else {
                    if (transaction.tipoSolicitacao == TRANSACTION_SOLICITE) {
                        NAVIGATION_PREV = "#servico_solicita";
                    }
                }
                NAVIGATION_NEXT = "#form";
                //fnValidNavigation = validaLocalidade;
                prepareLocalidade();
                break;
            case "form":
                NAVIGATION_PREV = "#localidade";
                NAVIGATION_NEXT = "#confirma";
                //fnValidNavigation = validaFormulario;
                prepareFormulario();
                break;
            case "confirm":
                NAVIGATION_PREV = "#form";
                prepareConfirm();
                break;
            case "servico_indica":
            case "servico_solicita":
                NAVIGATION_PREV = "#seleciona";
                prepareServico();
                break;
            case "finaliza":
                prepareFinaliza();
                break;
            case "masterPage":
                prepareLogin();
                break;
            case "tutorial":
                //prepareTutorial();     
                break;
            case "cadastro":
                prepareCadastro();
                break;
            case "tutorialAberto":
                prepareOpenTutorial();
                break;
            case "recuperarLogin":
                prepareRecuperarLogin();
                break;
        }
        //	prepareNavigation();
    }
    var onBackKeyDown = function (e)///trata o comando de back do android
    {
        e.preventDefault();
        if ($.mobile.activePage.attr("id") == "masterPage") {

            navigator.notification.confirm("Você realmente gostaria de deslogar do aplicativo?", confirmCallback, "Sair", "Sim,Não");

        } else {
            if ($.mobile.activePage.attr("id") == "splash") {
                navigator.app.exitApp();
            } else {

                if ($("#regulamentoPlaceHolder").length) {
                    //					$("#regulamentoPlaceHolder").getNiceScroll().remove();
                }
                if ($("#searchPainel").length) {
                    //				$("#searchPainel .listPlaces").getNiceScroll().remove();
                }
                prevPageNavigation();
            }
        }
        return false;
    }
    var confirmPendding = function (button) {
        if (button == 1) {
            transaction.getLocalStorageTransaction();
            $.mobile.changePage("#localidade", { transition: "slide" });
        } else {
            transaction.emptyLocalStorageTransaction();
        }
    }
    var confirmCallback = function (button) //verificação de se o usuário realmente deseja sair.
    {
        if (button == 1) {
            if (isAndroid() && ($.mobile.activePage.attr("id") == "masterPage" || $.mobile.activePage.attr("id") == "splash")) {
                navigator.app.exitApp();
            } else {
                $.mobile.changePage("index.html", { transition: "slidedown" });
                clearLocalStorageTransaction();
            }
        }

    }
    var setEvents = function () { // seta os eventos iniciais

        $(document).on('pageshow', onChangePageHandler);
        $(document).on('pageload', layoutHeightPercent);
        //        $(document).on('pagebeforechange',function(){
        //                       
        //                       if($("#map_canvas").length && $.mobile.activePage.attr("id") == "localidade"){
        //                            map=null;
        //                            $("#map_canvas").remove();
        //                       }
        //        });

        document.addEventListener("backbutton", onBackKeyDown, false);
        $(document).on('taphold', '[data-role=page]', function () {
            $('[data-position=fixed]').fixedtoolbar('toggle');
        });
        $(document).on('resize', '[data-role=page]', function () {
            $('[data-position=fixed]').fixedtoolbar('toggle');
        });

        $(".prevButton").click(prevPageNavigation);

        //eventos dos botões das divs
        $("#btLogin").click(fnLogar);
        $("#btCadastrarLogin").click(fnCadastroUsuario);
        $("#btSairCadastro").click(function (e) {
            e.preventDefault();
            $.mobile.changePage("index.html", { transition: "slide", reverse: true });
            return false;
        });
        // ====================== area confirmação
        $("#btConfirmEnter").click(btConfirmEnterEventHandler);
        // ====================== area form
        setEventsForm();
        $("#nextButtonForm").click(function (e) {
            e.preventDefault();
            abortConnection();
            if (validaFormulario()) {
                $.mobile.changePage("#confirm", { transition: "slide" });
            }
            return false;
        });

        // ====================== area de localidade
        $("#nextButtonLocalidade").click(function (e) {
            e.preventDefault();
            abortConnection();
            if (validaLocalidade()) {
                $.mobile.changePage("#form", { transition: "slide" });
            }
            return false;
        });
        // ================== area de seleção
        $("#btSairSelecione").click(function (e) {
            e.preventDefault();
            navigator.notification.confirm("Você realmente gostaria de deslogar do aplicativo?", confirmCallback, "Sair", "Sim,Não");
            return false;
        });
        $("#btIndicar").click(function () {

            transaction.tipoSolicitacao = TRANSACTION_INDIQUE;
            carregaPaginaServico();

        });

        $("#btSolicitar").click(function () {

            transaction.tipoSolicitacao = TRANSACTION_SOLICITE;
            carregaPaginaServico();

        });
		$("#btTutorial").click(function () {

            $.mobile.changePage("#tutorial", { transition: "slide" });

        });		
        // ===================== recuperar cadastro	
        $("#btCustonRecuperarSenha").click(function (e) {

            if ($("#tfEmailRecovery").val() != "" && IsEmail($("#tfEmailRecovery").val())) {
                username = "monument@";
                password = "P@ss!Q@W";
                getJson({ Email: $("#tfEmailRecovery").val() }, SERVICE_RECOVERY);
                $("#tfEmailRecovery").attr("disabled", true)

            } else {
                navigator.notification.alert("Por favor, digite seu email.", function () { }, "Aviso", "OK");
            }
            return false;
        });

        $(".btServico").click(function (e) {
            e.preventDefault();
            transaction.tipoServico = $(this).attr("href");
            $.mobile.changePage("#localidade", { transition: "slide" });
            return false;
        })

        //========= regulamento

        $("#btAceitarRegulamento").click(function () {
            if ($("#aceitoTermos").is(":checked")) {
                showMessage("Aguarde", 1);
                getJson({}, SERVICE_REGULATION);
            } else {

                showMessageAutoHide("Para prosseguir é necessário aceitar o regulamento!", 0);
            }


        });
        //== tutorial
        prepareTutorial();
		
		/*==========feedback cadastro*/
		$("#btOkFeedCadastro").click(function(e){
			e.preventDefault();
			getJson({}, SERVICE_LOGIN);
		})				

    }
    var prepareRecuperarLogin = function () {


    }
    /**================== montagem de telas =========================================*/
    /**/
    var prepareTutorial = function () {
        $("#pagesTutorial li, #pagesTutorial").height($("#tutorial").height());
        $("#pagesTutorial").show();

        $("#tutorial").swipe({
            //Generic swipe handler for all directions

            tap: function (event, target) {
                if (_self.paginationTutorial < $("#pagesTutorial li").length - 1) {
                    $("#pagintor li").removeClass("active");
                    _self.paginationTutorial++;
                    $("#pagintor li").eq(_self.paginationTutorial).addClass("active");
                    $("#pagesTutorial").animate({ scrollTop: ($("#pagesTutorial").height() * _self.paginationTutorial) }, 300);
                } else {


                    $.mobile.changePage("#seleciona", { transition: "slidedown" });
					_self.paginationTutorial = 0;
					$("#pagintor li").removeClass("active");
					$("#pagintor li").eq(_self.paginationTutorial).addClass("active");
					$("#pagesTutorial").animate({ scrollTop: ($("#pagesTutorial").height() * _self.paginationTutorial) }, 1);

                }
            },
            swipeUp: function (event, direction, distance, duration, fingerCount) {
                if (_self.paginationTutorial < $("#pagesTutorial li").length - 1) {
                    $("#pagintor li").removeClass("active");
                    _self.paginationTutorial++;
                    $("#pagintor li").eq(_self.paginationTutorial).addClass("active");
                    $("#pagesTutorial").animate({ scrollTop: ($("#pagesTutorial").height() * _self.paginationTutorial) }, 300);
                }
            },
            swipeDown: function (event, direction, distance, duration, fingerCount) {
                if (_self.paginationTutorial > 0) {
                    $("#pagintor li").removeClass("active");
                    _self.paginationTutorial--;
                    $("#pagintor li").eq(_self.paginationTutorial).addClass("active");
                    $("#pagesTutorial").animate({ scrollTop: ($("#pagesTutorial").height() * _self.paginationTutorial) }, 300);
                }
            },
            //Default is 75px, set to 0 for demo so any distance triggers swipe
            threshold: 0
        });


    }
    var prepareOpenTutorial = function () {
        $("#tutorialAberto img").unbind("tap");
        $("#tutorialAberto img").bind("tap", function () {
            $.mobile.changePage("index.html", { transition: "slide", reverse: true });

        });

    }
    var auxClearTimeOutControl = function () {
        countClick = 0;
        clearTimeout(controlClick);
    }
    var fnLogar = function (e) {
        e.preventDefault();
        if ($("#tfSenha").val() != "" && $("#tfLogin").val() != "") {
            showMessage('Aguarde autenticando...', 1);
            $("#loginMessage").text('Aguarde autenticando...');
            $("#placeLogin").hide();
            $("#tfSenha").attr("disabled", true);
            $("#tfLogin").attr("disabled", true);
            $("#btLogin").attr("disabled", true);

            username = $("#tfLogin").val();
            password = $("#tfSenha").val();

            getJson({}, SERVICE_LOGIN);

        } else {
            showMessageAutoHide("Por favor, digite seu email e senha.", 0);
        }

        return false;
    }
    var prepareLogin = function () /// monta tela de login
    {
        if (VERSION_CODE != "") {
            $("#lbVersionCode").html("versão: " + VERSION_CODE);
        }

        $("#loginMessage").text("");
        $("#placeLogin").show();
        $("#tfSenha").attr("disabled", false);
        $("#tfLogin").attr("disabled", false);
        $("#btLogin").attr("disabled", false);
    }
    var prepareRegulamento = function () // monta tela de regulamento
    {
        //		$("#regulamentoPlaceHolder").niceScroll({touchbehavior:true, cursoropacitymin : 1, cursorcolor : "#ff7800", background : "#c3c5c8"}); // First scrollable DIV		
    }
    var prepareSelecione = function () // monta tela de seleção do tipo do chamado
    {
        transaction = new Transacao(userToken);
        try {
            if (firstViewSelecione && transaction.hasPedding()) {
                var _tipo = tiposSolicitacao[window.localStorage.getItem("tipoSolicitacao")];
                var _servico = tiposSolicitacao[window.localStorage.getItem("tipoServico")];
                navigator.notification.confirm("Existe uma " + _tipo + "(" + _servico + ") pendente. Deseja finalizá-la?", confirmPendding, "Pendência", "Sim,Não");

            }
        } catch (error) {

        }
        firstViewSelecione = false;

    }
    var fnCadastroUsuario = function (e) {
        e.preventDefault();
        if (!$("#btCadastrarLogin").attr("disabled")) {


            if ($("#tfNomeCadastro").val() != "" && $("#tfSenhaCadastro").val() != "" && $("#tfEmailCadastro").val() != "") {

                if (!IsEmail($("#tfEmailCadastro").val())) {
                    showMessageAutoHide("O email fornecido não é valido. Por favor, verifique se você digitou corretamente.", 0)
                } else {

                    username = "monument@";
                    password = "P@ss!Q@W";

                    //						var strCPF = $("#tfCpfCadastro").val().replace(/[`~!@#$%^&*()_|+\-=?;:'",.<>\{\}\[\]\\\/]/gi, '');
                    getJson({ Nome: $("#tfNomeCadastro").val(), Email: $("#tfEmailCadastro").val(), Senha: $("#tfSenhaCadastro").val(), Sistema: (_isIOS ? "iOS" : "Android") }, SERVICE_REGISTER);
                    $("#btCadastrarLogin").attr("disabled", true);

                }

            } else {
                showMessageAutoHide("Por favor, preencha todos os campos obrigatórios.", 0)
            }


        }
        return false;
    }
    var prepareCadastro = function () {
        $("#btCadastrarLogin").attr("disabled", false);
        $("#tfCpfCadastro").mask("999.999.999-99");
    }
    var prepareServico = function () {
        //$(".btServico").unbind("tap");	

    }
    var prepareFinaliza = function () {

    }
    var prepareLocalidade = function () //monta tela de seleção da localidade
    {
        transaction.setLocalStorageTransaction();
        $("#mapAreaContent").empty();
        $("#mapAreaContent").html('<div id="map_canvas" class="light"><img src="images/loader_laranja.gif" style="display:block;padding-top: 20px;width 80px;margin: 0 auto;" id="mapLoad"></div>');
        $("#ChoicePlace").empty();
        initializeMap();

        $("#tfEndereco").val(transaction.endereco);
        $("#tfNumero").val(transaction.enderecoNumero);
        $("#tfComplemento").val(transaction.enderecoComplemento);
        $("#tfGeoPoint").val(transaction.geopoint);
        $("#tfGeoPointType").val(transaction.geopointType);
        $("#tfIdEvenue").val(transaction.idEvenue);
    }
    var prepareFormulario = function () //prepara tela de formulário de dados.
    {
        transaction.setLocalStorageTransaction();
        $("#tfLocalNome").val(transaction.endereco);
        $("#tfCnpj").val(transaction.cnpj);
        $("#tfNomePonto").val(transaction.pontoVenda);
        $("#tfContato").val(transaction.nomeContato);
        $("#tfNomeComercial").val(transaction.nomeComercial);
        $("#tfFixo").val(transaction.phoneFixo);
        $("#tfCelular").val(transaction.phoneCelular);
        $("#tfObs").val(transaction.observacao);

        if (transaction.tipoSolicitacao == 2) {
            $("#tfCnpj").attr("placeholder", "*CNPJ");
            $("#tfNomePonto").attr("placeholder", "*PV");
        }

        $("#btCnpj").removeClass("ui-btn-active");
        $("#btPontoVenda").removeClass("ui-btn-active");

        if ($("#tfNomePonto").val() != "") {
            $("#btPontoVenda").addClass("ui-btn-active");
            $("#fldPV").show();
            $("#fldCnpj").hide();
        } else {
            $("#btCnpj").addClass("ui-btn-active");
            $("#fldPV").hide();
            $("#fldCnpj").show();
        }
    }

    var setEventsForm = function () {
        $("#tfFixo").mask("(99) 9999-9999");
        //$("#tfCelular").mask(celphoneMask,options);
        $('#tfCelular').focusout(function () {
            var phone, element;
            element = $(this);
            element.unmask();
            phone = element.val().replace(/\D/g, '');
            if (phone.length > 10) {
                element.mask("(99) 99999-999?9");
            } else {
                element.mask("(99) 9999-9999?9");
            }
        }
		).trigger('focusout');

        $("#tfCnpj").mask("99.999.999/9999-99");
        $("#tfCnpj").blur(function () {

            if (!validarCNPJ($(this).val()) && $(this).val() != "") {
                showMessageAutoHide("O CNPJ digitado não é válido.", 0)
            }

        });

        $("#btCnpj").click(function () {

            $(this).addClass("ui-btn-active");
            $("#btPontoVenda").removeClass("ui-btn-active");
            $("#fldPV").hide();
            $("#fldCnpj").show();
            $("#tfNomePonto").val("");
            $("#tfCnpj").val("");
        });
        $("#btPontoVenda").click(function () {

            $(this).addClass("ui-btn-active");
            $("#btCnpj").removeClass("ui-btn-active");
            $("#fldPV").show();
            $("#fldCnpj").hide();
            $("#tfNomePonto").val("");
            $("#tfCnpj").val("");
        });
    }

    var btConfirmEnterEventHandler = function () {
        /*console.log("passou em btConfirmEnterEventHandler");
		$("#btConfirmEnter").unbind("tap");
		showMessage("Enviando dados...",1);*/
        getJson(transaction.toJsonObject(), SERVICE_OS);
        return false;
    }

    var prepareConfirm = function ()//prepara tela de confirmação.
    {

        transaction.setLocalStorageTransaction();
        if (transaction.pontoVenda != "") {
            $("#tfTipoId").text("PV");
            $("#lbCNPJ").html(valNaoFornecido(transaction.pontoVenda));
        } else {
            $("#tfTipoId").val("CNPJ");
            $("#lbCNPJ").html(valNaoFornecido(transaction.cnpj));
        }

        $("#lbEndereco").html(valNaoFornecido(transaction.endereco));
        $("#lbNomeContato").html(valNaoFornecido(transaction.nomeContato));
        $("#lbNomeComercial").html(valNaoFornecido(transaction.nomeComercial));
        $("#lbFixo").html(valNaoFornecido(transaction.phoneFixo));
        $("#lbCelular").html(valNaoFornecido(transaction.phoneCelular));
        $("#lbObs").html(valNaoFornecido(transaction.observacao));

    }



    /**
	* ================== funções de validação de forms
	*/
    var validaLocalidade = function () {
        /*
		if( $("#tfEndereco").val() == "")
		{
			showMessageAutoHide("Os campo endereço é obrigatório!",0);	
			return false;
		}*/
        transaction.endereco = $("#tfEndereco").val();
        transaction.enderecoNumero = $("#tfNumero").val();
        transaction.enderecoComplemento = $("#tfComplemento").val();
        transaction.geopoint = $("#tfGeoPoint").val();
        transaction.geopointType = $("#tfGeoPointType").val();
        transaction.idEvenue = $("#tfIdEvenue").val();

        return true;
    }
    var validaFormulario = function () {
        if (transaction.tipoSolicitacao == 2 && $("#tfCnpj").val() == "" && $("#tfNomePonto").val() == "") {
            showMessageAutoHide("Você deve indicar o CNPJ ou PV.", 0);
            return false;
        }
        if ($("#tfContato").val() == "" || $("#tfFixo").val() == "" || $("#tfFixo").val() == "(__) ____-____") {
            $("#tfFixo").val("");
            showMessageAutoHide("Os campos Nome Contato e Telefone Fixo são obrigatórios.", 0);
            return false;
        }
        if ($("#tfFixo").val().length < 14) {
            showMessageAutoHide("O campo telefone fixo não está preenchido corretamente! " + $("#tfFixo").val().length, 0);
            return false;
        }

        transaction.cnpj = $("#tfCnpj").val();
        transaction.pontoVenda = $("#tfNomePonto").val();
        transaction.nomeContato = $("#tfContato").val();
        transaction.nomeComercial = $("#tfNomeComercial").val();
        transaction.phoneFixo = $("#tfFixo").val();
        transaction.phoneCelular = $("#tfCelular").val();
        transaction.observacao = $("#tfObs").val();

        return true;
    }
    /**
		===== funções de retorno dos serviços
	*/
    var getJson = function (_data, serviceRequest) {
        var json = JSON.stringify(_data);
        console.log("=== " + json);
        requesterAjax = $.ajax({
            type: "POST",
            url: BASE_URL + serviceRequest.url,
            contentType: "application/json", //Usado na solicitação Json
            //dataType: "json",
            data: json, //Usando json
            timeout: 10000,
            beforeSend: function (xhr) {

                xhr.setRequestHeader('Authorization', make_base_auth(username, password));

            },
            success: function (res) {
                console.log("passou no sucesso ajax.");
                switch (serviceRequest.type) {
                    case SERVICE_LOGIN.type:
                        //						navigator.splashscreen.hide();	
                        returnLogin(res);
                        break;
                    case SERVICE_REGULATION.type:
                        returnRegulamento(res)
                        break;
                    case SERVICE_FOUR_SQUARE.type:
                        mountMap(res);
                        break;
                    case SERVICE_OS.type:
                        clearNavigationControls();
                        transaction.emptyLocalStorageTransaction();
                        $.mobile.changePage("#finaliza", { transition: "flip" });
                        break;
                    case SERVICE_REGISTER.type:
                        //						var strCPF = $("#tfCpfCadastro").val().replace(/[`~!@#$%^&*()_|+\-=?;:'",.<>\{\}\[\]\\\/]/gi, '');                        

						if(res.Codigo < 0){
							$("#btOkFeedCadastro").hide();							 
							
						}else{
							$("#btOkFeedCadastro").show();							
							username = $("#tfEmailCadastro").val();
	                        password = $("#tfSenhaCadastro").val();								
						}
						$("#lbFeedCadastro").html(res.Mensagem);
						
						$("#tfNomeCadastro").val("");
						$("#tfEmailCadastro").val("");
						$("#tfSenhaCadastro").val("");				
					//	navigator.notification.alert(res.Mensagem, function () { getJson({}, SERVICE_LOGIN); }, "Cadastro", "OK");                        
						$.mobile.changePage("#feedCadastro", { transition: "slideup" });							

                        break;
                    case SERVICE_RECOVERY.type:
                        $("#tfEmailRecovery").attr("disabled", false)
                        $("#tfEmailRecovery").val("");
                        navigator.notification.alert(res.Mensagem, function () { }, "AVISO", "OK");
                        $('.ui-dialog').dialog('close');
                        break;
                }
            },
            error: function (jqXHR, textStatus, errorThrown) {
                hideMessage();
                $("#tfEmailRecovery").attr("disabled", false)
                $("#btCadastrarLogin").attr("disabled", false);
                console.log("passou no error ajax: " + jqXHR.status + ", " + errorThrown);
                switch (serviceRequest.type) {

                    case SERVICE_REGISTER.type:
                        if (jqXHR.status == 407) {
                            navigator.notification.alert("Não foi possível concluir o cadastro no momento. Caso esta situação persista, entre em contato com o Suporte.", function () { }, "AVISO", "OK");
                        } else {
                            if (jqXHR.status == 411) {
                                navigator.notification.alert("O email informado já está cadastrado.", function () { }, "AVISO", "OK");
                            } else {
                                navigator.notification.alert("Não foi possível concluir sua solicitação no momento. Talvez sua conexão à internet esteja lenta ou apresenta algum problema. Por favor, tente novamente dentro de alguns instantes." + jqXHR.status + " " + serviceRequest.type, function () { }, "ERRO", "OK");
                            }
                        }
                        break;
                    case SERVICE_LOGIN.type:
                        navigator.splashscreen.hide();
                        if (jqXHR.status == 401) {
                            //caso 401 é um erro claro de negação
                            navigator.notification.alert("O email ou a senha inseridos estão incorretos. Verifique se digitou corretamente e tente novamente.", function () { }, "AVISO", "OK");
                        }
                        else {
                            //caso seja qualquer outro codigo, será considerado problema de internet
                            navigator.notification.alert("Não foi possível verificar o email/senha inseridos. Verifique se você está conectado à internet, e se digitou corretamente os dados.", function () { }, "INFORMAÇÃO", "OK");
                        }

                        if ($.mobile.activePage.attr("id") != "masterPage") {
                            $.mobile.changePage("index.html", { transition: "slidedown" });
                        }
                        else {
                            $("#loginMessage").text("");
                            $("#placeLogin").show();
                            $("#tfSenha").attr("disabled", false);
                            $("#tfLogin").attr("disabled", false);
                            $("#btLogin").attr("disabled", false);
                        }

                        break;

                    default:
                        if (serviceRequest.type === SERVICE_OS.type) {
                            $("#btConfirmEnter").bind("tap", btConfirmEnterEventHandler);
                        }
                        //em todas as operaçoes do serviço sempre é retorna sucesso, então se chegou aqui, será considerado problema de internet.
                        navigator.notification.alert("Não foi possível concluir sua solicitação no momento. Talvez sua conexão à internet esteja lenta ou apresenta algum problema. Por favor, tente novamente dentro de alguns instantes. " + jqXHR.status + " " + serviceRequest.type, function () { }, "ERRO", "OK");
                        break;
                }

            }
        });

    }
    var returnLogin = function (res) {
        if (res.Ativo) {
            try {
                window.localStorage.setItem("token", res.Token);
                window.localStorage.setItem("username", username);
                window.localStorage.setItem("password", password);
            } catch (error) {

            }

            hideMessage();
            userToken = res.Token;
            regulamentoAceito = res.AceitouRegulamento;
            $("body").removeClass("bgHome");
            //console.log("regulamentoAceito: "+regulamentoAceito);
            //$.mobile.changePage( "tutorial.html", { transition: "slideup" });

            if (!regulamentoAceito) {

                $.mobile.changePage("#home", { transition: "slideup" });
            } else {
                $.mobile.changePage("#seleciona", { transition: "slideup" });
            }
        } else {
            showMessageAutoHide(res.Mensagem, 0);
            $("#tfSenha").attr("disabled", false);
            $("#tfLogin").attr("disabled", false);
            $("#tfSenha").val("");
            $("#tfLogin").val("");
            $("#btLogin").attr("disabled", false);
            $("#loginMessage").text("");
            $("#placeLogin").show();

        }
    }
    var returnRegulamento = function () {
        hideMessage()

        $.mobile.changePage("#tutorial", { transition: "slide" });

    }

    /** 
		============== funções auxiliares
	*/
    var carregaPaginaServico = function () {

        if (transaction.tipoSolicitacao == TRANSACTION_INDIQUE) {
            $.mobile.changePage("#servico_indica", { transition: "slide" });
        } else {
            if (transaction.tipoSolicitacao == TRANSACTION_SOLICITE) {
                $.mobile.changePage("#servico_solicita", { transition: "slide" });
            }
        }
    }
    var make_base_auth = function (user, password) {//cria o hash do cabecalho
        var tok = user + ':' + password;
        var hash = $.base64.btoa(tok);
        return "Basic " + hash;
    }
    var showMessage = function (message, type) //mostra mensagem como ligth box.
    {
        clearTimeout(ctrlAutoHideMessage);
        if (type == 0) {
            //	navigator.notification.vibrate(1000);
            //	$.mobile.showPageLoadingMsg("e", message, true);
            navigator.notification.alert(message, function () { }, "AVISO", "OK");
        }/*else{
			if(type == 1)
			{
				$.mobile.loading( 'show', {
							text: message,
							textVisible: true,
							theme: 'e',
							html: ""
						});
			}
		}*/
    }
    var showMessageAutoHide = function (message, type) //mostra mensagem como ligth box e fecha ela após 4 segundos
    {
        clearTimeout(ctrlAutoHideMessage);
        showMessage(message, type);
        ctrlAutoHideMessage = setTimeout(hideMessage, 4000);
    }
    var hideMessage = function () //oculta mensagem do ligth box.
    {
        $.mobile.loading('hide');
    }
    var layoutHeightPercent = function () //faz ajuste do percetunal do height
    {
        var heSize = $(window).height();
        $(".heightToPercent").each(function (index, element) {

            var itemHeight = $(this).attr("height") / 100;
            $(this).height(itemHeight * heSize);

        });
        $(".screenCenter").each(function (index, element) {

            // console.log( $(this).height() +" == "+ heSize );

        });
    }
    var initializeMap = function () { //inicializa mapa e gps

        showMessage('Conectando GPS...', 1);
        navigator.geolocation.clearWatch(watchID);
        watchID = navigator.geolocation.watchPosition(
			function (position) {//sucess

			    initialPointMap.x = position.coords.latitude;
			    initialPointMap.y = position.coords.longitude;
			    geoPositionAccuracy = position.coords.accuracy;
			    // 				alert('Buscando estabelecimentos...');
			    getJson({ Latitude: initialPointMap.x, Longitude: initialPointMap.y }, SERVICE_FOUR_SQUARE);
			    navigator.geolocation.clearWatch(watchID);
			},
			function () {//error
			    // 				console.log("falha!");
			    showMessage('Não foi possível determinar sua posição através do GPS no momento. Desta forma o mapa não será carregado.', 0);
			    //getJson({Latitude : initialPointMap.x, Longitude : initialPointMap.y},SERVICE_FOUR_SQUARE);		
			    navigator.geolocation.clearWatch(watchID);
			},
			{
			    enableHighAccuracy: true
					  , timeout: 15000
					  , frequency: 3000
			}
			);


    }
    var mountMap = function (res) //monta mapa do google maps.
    {
        $("#mapLoad").remove();
        hideMessage();
        places = [];
        $("#tfGeoPoint").val(initialPointMap.x + "," + initialPointMap.y);
        $("#tfGeoPointType").val("local");

        var map1 = L.mapbox.map('map_canvas', 'michaelpimentel.map-cazaqeae', { zoomControl: false })
        .setView([initialPointMap.x, initialPointMap.y], DefaultMapZoom);

        var geoJson = {
            type: 'FeatureCollection',
            features: []
        };



        //        map = new google.maps.Map(document.getElementById('map_canvas'),mapOptions);
        //		infowindow = new google.maps.InfoWindow();
        //	console.log(res.length + " total places")
        for (var t = 0; t < res.length; t++) {
            var place = res[t];
            var strLi = '<li id="gm' + place.id + '"><a geo="' + place.lat + "," + place.lng + '" data="' + nullToEmpty(place.endereco) + '" href="' + place.id + '">' + nullToEmpty(place.nome) + '</a></li>';
            $("#ChoicePlace").append(strLi);
            places[place.id] = place;

            var imgURL = (isAndroid()) ? "./images/gr/maps_marker.png" : "./images/gr/maps_marker_ios.png";

            geoJson.features.push({
                type: 'Feature',
                properties: {
                    title: place.nome,
                    "icon": {
                        "iconUrl": imgURL,
                        "iconSize": [60, 50],
                        "iconAnchor": [30, 28],
                        "popupAnchor": [0, 0]
                    },
                    placeId: place.id,
                    lugar: place.lat + "," + place.lng,
                    endereco: nullToEmpty(place.endereco),
                    nome: nullToEmpty(place.nome)

                },
                geometry: {
                    type: 'Point',
                    coordinates: [place.lng, place.lat]
                }
            });

            /*var marker = new google.maps.Marker({
				map:map,
				draggable:false,
				animation: google.maps.Animation.DROP,
				position: new google.maps.LatLng(place.lat, place.lng),
				icon : imgURL
			});		
			marker.id = place.id;			
			bindInfoWindow(marker,map,infowindow,place.nome);*/

        }

        map1.markerLayer.on('layeradd', function (e) {
            var marker = e.layer,
            feature = marker.feature;
            marker.setIcon(L.icon(feature.properties.icon));
        });

        map1.markerLayer.setGeoJSON(geoJson);

        map1.markerLayer.on("click", function (e) {
            bindInfoWindow1(e.layer.feature.properties);
        });

        var circle_options = {
            color: '#fff',
            opacity: 1,
            weight: 4,
            fillColor: '#ff7800',
            fillOpacity: 0.2
        };

        L.circle([initialPointMap.x, initialPointMap.y], (geoPositionAccuracy / 2), circle_options).addTo(map1);

        $("#ChoicePlace").append('<li class="choiceAnother"><a href="#" id="btSelecionarOutro">Selecionar outro</a></li>');
        $("#ChoicePlace").fadeIn();

        $("#ChoicePlace li a").unbind("tap");
        $("#ChoicePlace li a").bind("tap", function (e) {
            e.preventDefault();

            if ($(this).attr("id") != "btSelecionarOutro") {

                //	var place = places[ $(this).attr("href")];
                $("#tfEndereco").val($(this).attr("data"));
                $("#tfGeoPoint").val($(this).attr("geo"));
                $("#tfGeoPointType").val("foursquare");
                $("#tfIdEvenue").val($(this).attr("href"));
                var geoLo = $(this).attr("geo").split(",");

                map1.panTo([geoLo[0], geoLo[1]]);

                $("#ChoicePlace li").hide();
                $(this).parent().show();
                $("#btSelecionarOutro").parent().show();
                $("#searchPainel .listPlaces").animate({ scrollTop: 0 }, 100);
                transaction.nomeEstabelecimento = $(this).text();
            } else {
                //$("#searchPainel .listPlaces").niceScroll({touchbehavior:true, cursoropacitymin : 1, cursorcolor : "#ff7800", background : "#c3c5c8"}); 
                $("#ChoicePlace li").show();
                $("#btSelecionarOutro").parent().hide();

                $("#tfEndereco").val("");
                $("#tfGeoPoint").val("");
                $("#tfGeoPoint").val(initialPointMap.x + "," + initialPointMap.y);
                $("#tfGeoPointType").val("local");
            }
            return false;
        });
        //		$("#searchPainel .listPlaces").niceScroll({touchbehavior:true, cursoropacitymin : 1, cursorcolor : "#ff7800", background : "#c3c5c8"}); // First scrollable DIV	
        if (transaction.idEvenue != null && transaction.idEvenue != "") {
            var place = places[transaction.idEvenue];
            $("#tfEndereco").val(place.endereco);
            $("#tfGeoPoint").val(place.lat + "," + place.lng);
            $("#tfGeoPointType").val("foursquare");
            $("#tfIdEvenue").val(place.id);
            //map.panTo(new google.maps.LatLng(place.lat, place.lng));
            $("#ChoicePlace li").hide();
            $("#gm" + place.id).show();
            $("#btSelecionarOutro").parent().show();
            $("#searchPainel .listPlaces").animate({ scrollTop: 0 }, 100);
        }
    }
    var bindInfoWindow = function (marker, map, infowindow, html) {
        /*google.maps.event.addListener(marker, 'click', function() {
			infowindow.setContent(html);
			infowindow.open(map, marker);			
			var place = places[marker.id];
			transaction.nomeEstabelecimento = place.nome;
			$("#tfEndereco").val(place.endereco);
			$("#tfGeoPoint").val(place.lat+","+place.lng);
			$("#tfGeoPointType").val("foursquare");	
			$("#tfIdEvenue").val(marker.id);	
			$("#ChoicePlace li").hide();			
			$("#gm"+marker.id).show();
			$("#btSelecionarOutro").parent().show();
			$("#searchPainel .listPlaces").animate({scrollTop:0}, 100);
				
		});*/
    }
    var bindInfoWindow1 = function (proper) {

        //		$("#searchPainel .listPlaces").getNiceScroll().remove();
        transaction.nomeEstabelecimento = proper.nome;
        $("#tfEndereco").val(proper.endereco);
        $("#tfGeoPoint").val(proper.lugar);
        $("#tfGeoPointType").val("foursquare");
        $("#tfIdEvenue").val(proper.placeId);
        $("#ChoicePlace li").hide();
        $("#gm" + proper.placeId).show();
        $("#btSelecionarOutro").parent().show();
        $("#searchPainel .listPlaces").animate({ scrollTop: 0 }, 100);
    }
    var layoutAdapter = function () //converte o body para as classes, seja android ou iphone.
    {
        var ua = navigator.userAgent.toLowerCase();
        _isIOS = ua.indexOf("iphone") > -1;
        _isAndroid = ua.indexOf("android") > -1;
        var heSize = $(window).height();

        if (isAndroid()) {
            $("body").attr("id", "androidContent");
            if (heSize <= 762) {
                $("body").addClass("minHeight");
            }

            DefaultMapZoom = 18;
            if (ua.indexOf("4.0.4") > -1) {
                androidBugado = true;
            }
        } else {
            if (isIOS()) {
                $("body").attr("id", "iphoneContent");


                if (heSize <= 480) {
                    $("body").addClass("minHeight");
                }
                if (parseFloat(window.device.version) === 7.0) {
                    $("body").addClass("ios7");
                }
                DefaultMapZoom = 17;
            }
        }

    }
    /** ======= funções utils
	*/
    var isAndroid = function () //true se sistema operaciona android
    {
        return _isAndroid;
    }
    /***/
    var isIOS = function ()//true se o sistema operacional for iphone
    {
        return _isIOS;
    }
    var valNaoFornecido = function (val) {
        return (val == "") ? "Não fornecido" : val;
    }
    var clearLocalStorageTransaction = function () {
        try {
            window.localStorage.clear();
        } catch (error) { }
    }
    var cleanCPF = function (str) {
        str = str.replace(".", "");
        str = str.replace(".", "");
        str = str.replace(".", "");
        str = str.replace("-", "");

        return str;
    }
    var celphoneMask = function (phone, e, currentField, options) {
        return phone.match(/^(\(?11\)? ?9(5[0-9]|6[0-9]|7[01234569]|8[0-9]|9[0-9])[0-9]{1})/g) ? '(00) 00000-0000' : '(00) 0000-0000';
    };
    var nullToEmpty = function (val) {
        return (val) ? val : "";
    }
    var IsEmail = function (email) {
        var filter = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;
        if (filter.test(email))
            return true;
        else {
            return false;
        }
    }
    function valCpf(cpf) {
        cpf = cleanCPF(cpf);
        var numeros, digitos, soma, i, resultado, digitos_iguais;
        digitos_iguais = 1;
        if (cpf.length < 11)
            return false;
        for (i = 0; i < cpf.length - 1; i++)
            if (cpf.charAt(i) != cpf.charAt(i + 1)) {
                digitos_iguais = 0;
                break;
            }
        if (!digitos_iguais) {
            numeros = cpf.substring(0, 9);
            digitos = cpf.substring(9);
            soma = 0;
            for (i = 10; i > 1; i--)
                soma += numeros.charAt(10 - i) * i;
            resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
            if (resultado != digitos.charAt(0))
                return false;
            numeros = cpf.substring(0, 10);
            soma = 0;
            for (i = 11; i > 1; i--)
                soma += numeros.charAt(11 - i) * i;
            resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
            if (resultado != digitos.charAt(1))
                return false;
            return true;
        }
        else
            return false;
    }
    var validarCNPJ = function (cnpj) {

        cnpj = cnpj.replace(/[^\d]+/g, '');

        if (cnpj == '') return false;

        if (cnpj.length != 14)
            return false;

        // Elimina CNPJs invalidos conhecidos
        if (cnpj == "00000000000000" ||
			cnpj == "11111111111111" ||
			cnpj == "22222222222222" ||
			cnpj == "33333333333333" ||
			cnpj == "44444444444444" ||
			cnpj == "55555555555555" ||
			cnpj == "66666666666666" ||
			cnpj == "77777777777777" ||
			cnpj == "88888888888888" ||
			cnpj == "99999999999999")
            return false;

        // Valida DVs
        tamanho = cnpj.length - 2
        numeros = cnpj.substring(0, tamanho);
        digitos = cnpj.substring(tamanho);
        soma = 0;
        pos = tamanho - 7;
        for (i = tamanho; i >= 1; i--) {
            soma += numeros.charAt(tamanho - i) * pos--;
            if (pos < 2)
                pos = 9;
        }
        resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
        if (resultado != digitos.charAt(0))
            return false;

        tamanho = tamanho + 1;
        numeros = cnpj.substring(0, tamanho);
        soma = 0;
        pos = tamanho - 7;
        for (i = tamanho; i >= 1; i--) {
            soma += numeros.charAt(tamanho - i) * pos--;
            if (pos < 2)
                pos = 9;
        }
        resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
        if (resultado != digitos.charAt(1))
            return false;

        return true;

    }

}

$(function () {
    //------teste web
    //new Main().init();
    //------teste mobile
    document.addEventListener('deviceready', function () { new Main().init(); }, false);


})
/**
* Objeto para transação da os
*/
function Transacao(userToken) {
    this.userToken = userToken;
    this.tipoSolicitacao = ""; //1 == indicação ; 2 == relacionamento.
    this.tipoServico = ""; // 3 , 4 , 5 , 6 , 7 , 8
    this.geopoint = "";//fourscare ou local
    this.geopointType = ""; //forusquere ou local atual definição..
    this.idEvenue = "";//valor da id do four scquare.
    this.nomeEstabelecimento = "";
    this.endereco = "";//
    this.enderecoNumero = "";
    this.enderecoComplemento = "";
    this.estabelecimentoTipo = "";//1 cnpj e 2 para ponto de venda
    this.cnpj = "";
    this.pontoVenda = "";
    this.nomeContato = "";
    this.nomeComercial = "";
    this.phoneFixo = "";
    this.phoneCelular = "";
    this.observacao = "";


    this.toJsonObject = function () //montar json
    {

        var clearedCNPJ = this.cnpj.replace(/[^\d]+/g, '');
        var jSonObject = {};
        jSonObject.contato = this.nomeContato;
        jSonObject.CNPJ = clearedCNPJ;
        jSonObject.NomeComercial = this.nomeComercial;
        jSonObject.NomeEstabelecimento = this.nomeEstabelecimento;
        jSonObject.PV = this.pontoVenda;
        jSonObject.Telefone = this.phoneFixo;
        jSonObject.Celular = this.phoneCelular;
        jSonObject.GeoPoint = this.geopoint;
        jSonObject.GeoPointType = this.geopointType;
        jSonObject.IdEvenue = this.idEvenue;
        jSonObject.Endereco = this.endereco;
        jSonObject.EnderecoNumero = this.enderecoNumero;
        jSonObject.Complemento = this.enderecoComplemento;
        jSonObject.Observacao = this.observacao;
        jSonObject.TipoSolicitacao = parseInt(this.tipoSolicitacao);
        jSonObject.TipoServico = parseInt(this.tipoServico);

        return jSonObject;

    }
    this.hasPedding = function () {
        try {
            return window.localStorage.getItem("tipoSolicitacao") != null && window.localStorage.getItem("tipoServico") != null;
        } catch (error) {
            return false;
        }
    }
    this.setLocalStorageTransaction = function () {
        try {
            window.localStorage.setItem("tipoSolicitacao", this.tipoSolicitacao);
            window.localStorage.setItem("tipoServico", this.tipoServico);
            window.localStorage.setItem("geopoint", this.geopoint);
            window.localStorage.setItem("geopointType", this.geopointType);
            window.localStorage.setItem("geopointType", this.geopointType);
            window.localStorage.setItem("idEvenue", this.idEvenue);
            window.localStorage.setItem("endereco", this.endereco);
            window.localStorage.setItem("enderecoNumero", this.enderecoNumero);
            window.localStorage.setItem("enderecoComplemento", this.enderecoComplemento);
            window.localStorage.setItem("estabelecimentoTipo", this.estabelecimentoTipo);
            window.localStorage.setItem("cnpj", this.cnpj);
            window.localStorage.setItem("pontoVenda", this.pontoVenda);
            window.localStorage.setItem("nomeContato", this.nomeContato);
            window.localStorage.setItem("nomeComercial", this.nomeComercial);
            window.localStorage.setItem("NomeEstabelecimento", this.nomeEstabelecimento);
            window.localStorage.setItem("phoneFixo", this.phoneFixo);
            window.localStorage.setItem("phoneCelular", this.phoneCelular);
            window.localStorage.setItem("observacao", this.observacao);
        } catch (error) {

        }
    }
    this.emptyLocalStorageTransaction = function () {
        try {
            window.localStorage.removeItem("tipoSolicitacao");
            window.localStorage.removeItem("tipoServico");
            window.localStorage.removeItem("geopoint");
            window.localStorage.removeItem("geopointType");
            window.localStorage.removeItem("geopointType");
            window.localStorage.removeItem("idEvenue");
            window.localStorage.removeItem("endereco");
            window.localStorage.removeItem("enderecoNumero");
            window.localStorage.removeItem("enderecoComplemento");
            window.localStorage.removeItem("estabelecimentoTipo");
            window.localStorage.removeItem("cnpj");
            window.localStorage.removeItem("pontoVenda");
            window.localStorage.removeItem("nomeContato");
            window.localStorage.removeItem("nomeComercial");
            window.localStorage.removeItem("NomeEstabelecimento");
            window.localStorage.removeItem("phoneFixo");
            window.localStorage.removeItem("phoneCelular");
            window.localStorage.removeItem("observacao");
        } catch (error) { }
    }
    this.getLocalStorageTransaction = function () {
        try {
            this.tipoSolicitacao = nullToEmpty(window.localStorage.getItem("tipoSolicitacao")); //1 == indicação ; 2 == relacionamento.
            this.tipoServico = nullToEmpty(window.localStorage.getItem("tipoServico")); // 3 , 4 , 5 , 6 , 7 , 8
            this.geopoint = nullToEmpty(window.localStorage.getItem("geopoint"));//fourscare ou local
            this.geopointType = nullToEmpty(window.localStorage.getItem("geopointType")); //forusquere ou local atual definição..
            this.idEvenue = nullToEmpty(window.localStorage.getItem("idEvenue"));//valor da id do four scquare.
            this.endereco = nullToEmpty(window.localStorage.getItem("endereco"));//
            this.enderecoNumero = nullToEmpty(window.localStorage.getItem("enderecoNumero"));
            this.enderecoComplemento = nullToEmpty(window.localStorage.getItem("enderecoComplemento"));
            this.estabelecimentoTipo = nullToEmpty(window.localStorage.getItem("estabelecimentoTipo"));//1 cnpj e 2 para ponto de venda
            this.cnpj = nullToEmpty(window.localStorage.getItem("cnpj"));
            this.pontoVenda = nullToEmpty(window.localStorage.getItem("pontoVenda"));
            this.nomeContato = nullToEmpty(window.localStorage.getItem("nomeContato"));
            this.nomeComercial = nullToEmpty(window.localStorage.getItem("nomeComercial"));
            this.nomeEstabelecimento = nullToEmpty(window.localStorage.getItem("NomeEstabelecimento"));
            this.phoneFixo = nullToEmpty(window.localStorage.getItem("phoneFixo"));
            this.phoneCelular = nullToEmpty(window.localStorage.getItem("phoneCelular"));
            this.observacao = nullToEmpty(window.localStorage.getItem("observacao"));
        } catch (error) { }
    }
    var nullToEmpty = function (val) {
        return (val) ? val : "";
    }

}